# Intro

This API adds the ability to make cards cost life + currency in act 1, and and act 2. It also allows Sigil makers to easily make Activated Sigils that cost Life, money, or the hybrid version. It's features include...

- Art that matches vanilla style for the cost for act 1 and act 2, which scales up to 15.
- Cost render support with art that matches the art in the cost render fix, for those who want to do hybrid costs
- Cards that cost life will show up as a cost choice at cost choice nodes
- Json loader support thru a dumb trick
- The ability to choose if you want one of the cards to use just Life or just Currency thru Sigils or special abilities (See below).
- Custom act 2 icons (both vanilla and Cost Render Fix) for just currency using cards and just life using cards
- Six Life / Currency active Sigils for people to playwith.

## How to use: Mod makers

Here are instructions on how to use this API as a person who codes with a bepinEX plugin

- Add the mod as a dependency in your project
- at your main plugins file, add "using LifeCost;"
- at "private void Start()", use card loader to call the cards you want to add a life cost to. an example would be this... "CardLoader.GetCardByName("lifecost_example").LifeCostz(3);". This would set the life cost of the card "lifecost_example" to 3. 
- Another trick you can do if you don't want to do above is when adding the card thru "NewCard.Add()", is set the energy cost to the negative amount you want the card to cost. the API will find any negative energy costs at launch and convert them to life costs.

This mod also allows you to make active sigils easily that cost life, money, or both. Follow the instructions below to figure out how!

- Add this mod as a dependency, and then when making the ability class, extend LifeCost.sigils.LifeActiveAbilityCost
- This allows you to set the cost of active abilities to Life, Money, Life+Money, Energy, or Bone (or a mix of the 4 Options).
- DO NOT mix the Life+Money option with the Life or money option. Life+Money is a special option that will substitute any lacking funds with life.
- Includes templates of the activated sigils base when you download this mod, if you want to keep consistent with it.


## How to use: Jsonloader users

Here are instructions on how to use this API as a person who makes cards in jsonloader

- Set the energy cost of the card to a negative value. 
- So if you want a card to cost 7 in life+currency, set the energyCost to -7

## What if I only want to a card to use Life / What if I want a card to only use Currency?

Here are instructions on how to use this API to make a card cost ONLY life or ONLY currency.

for ONLY life you want...

- To add the sigil ability to the card: Vampiric.
- The GUID for the ability is "extraVoid.inscryption.LifeCost". The name is Vamperic.

- To add the special ability to the card: Vampiric.
- The GUID for the special ability is "extraVoid.inscryption.LifeCost". The name is VampericSpecialAbility.


for ONLY currency you want...

- To add the sigil ability to the card: Greedy.
- The GUID for the ability is "extraVoid.inscryption.LifeCost". The name is Greedy.

- To add the special ability to the card: Greedy.
- The GUID for the special ability is "extraVoid.inscryption.LifeCost". The name is GreedySpecialAbility.

## Sigils for Modmakers to use...

These are under the GUID of "extraVoid.inscryption.LifeCost"

- "Max Energy Gamble" : Pay 6 energy to put 0 to 3 damage on someone's side of the scale
- "Cash Converter" : Pay 4 foils to put 1 damage on the opponent's side of the scale
- "Life Converter" : Pay 1 life to gain 2 foils
- "Vamperic Strength" : Pay 3 life to increase power and health by 1
- "Greedy Strength" : Pay 5 currency to increase power and health by 1
- "Die Roll" : Pay 3 life for the card bearing this sigil to gain between 0 and 6 increased in stats, distributed randomly

## Suggestions on balancing life cost cards

Just some helpful tips I noticed when making this and play testing

- Never make the attack of a card more than what it costs in life. For example: a card with 1 attack would cost between 2 and 3 in life. So it takes 2 to 3 turns to make up for the lost in life.
- In act 1, I would generally suggest following the 1:1 point system like bones and energy does. 
- In act 2, be VERY careful with balancing your cards. I highly suggest giving them the Vamperic Sigil, to make them only cost life. This is due to players being able to farm foils at the training dummy.
- Try to avoid bone or energy hybrid costs. 
- In the end, play by ear and heart like always. if something feels too good, then nerf it. If it feels too weak, then buff it.

## Installation (automated)
This is the recommended way to install the API on the game.

- Download and install [Thunderstore Mod Manager](https://www.overwolf.com/app/Thunderstore-Thunderstore_Mod_Manager) or [r2modman](https://timberborn.thunderstore.io/package/ebkr/r2modman/)
- Click Install with Mod Manager button on top of the [page]
- Run the game via the mod manager

# HELP WANTED

I am looking for help as there are a few things beyond my skills that I can't do (at least for now).

- I need help getting foils to show up on the game board during act 2 battles, so players don't need to hit escape to see how many they have.

- I need help tracking down and fixing a bug where the currency bowl and rulebook in act 1 will fly off screen. This happens usually in the third or second map (mainly third) and often during totem battles.

Contact me on discord if you are interested in helping me!


## Change log
v1.6.0
- Optimized rendercode to call art by name with a string instead of using a switch statement of the cost.
- Added Life / Money / Life+Money Activated Sigil Class
- Added "Max Energy Gamble", "Cash Converter", "Life Converter", "Vamperic Strength", "Greedy Strength", and "Die Roll" activated sigils for examples to mod makers
- Reorganized the assets, which is just a completely internal change and has nothing to do with end users.
- Fixed a few act 2 bugs
- Updated Teck to use "Vamperic Strength"


v1.5.0
- Patched Fair hand since it exists in the game to include life+currency cards
- Patched cost tier getter to include lifecost cards, at the price of 1/2 point like energy.

v1.4.1
- Made it so when leshy adds teeth to the currency bowl from combat, it doesnt teleport around.
- Updated Cost choice cardback to match better with the other two

v1.4.0
- Adjusted speed at which the currency bowl in act 1 gets place on setup, so teeth doesnt spill all over
- Added config for the speed at which the currency bowl in act 1 falls, for those who liked the original speed
- Adjusted and cleaned up act 2 stuff, tested and functions
- Updated readme with stuff that was missed in the v1.3.0 update

v1.3.0
- Fixed issue with API versions 1.13.1 or higher

v1.2.3
- Fixed null error during deathcard creation

v1.2.2
- Fixed null error at the choice node (which happened by the player not having any life cost cards learned) by just giving a teck to the player.

v1.2.1
- Fixed null error in getting a hint from leshy

v1.2.0
- Added the Greedy Sigil, for those who want to make their card cost JUST currency
- Added the Vamperic Sigil, for those who want to make their card cost JUST life

v1.1.0
- adjust the timing of paying the cost with the help of xXxStoner420BongMasterxXx so it doesnt conflict on resolve abilities hopefully.

v1.0.0
- initial release

## Licenses
This mod is under the MIT licenses. That means you are free to take, modify, and redistribute this mod as you wish as long as the resulting product is also under the MIT license. 

## Credits

xXxStoner420BongMasterxXx, BLIND, Eri, Memez4life, Dragon, Kopie, Ara, Digi, Sire, Nevernamed for help in various aspects of this mod

